# -*- coding: utf-8 -*-
"""__init__.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/19Of8nHyGT6VxYBhFiE71YTl6LtEfT4VK
"""

# from .Wave import Wave
# from .Processor import TimeSeriesSplit, extract_model_weights_from_dict, extract_predictions_from_dict
# from .Wave import generate_train_end_date, generate_test_start_date
# from .Predictions import wave_prediction, seperate_model_eval, find_prediction_current_week, wave_prediction_with_models, model_eval_on_future
# from .Visualization import visualize_wave_shifts, visualize_weekly_case_count_all_model_each_wave, visualize_weekly_MAPE_all_model_each_wave, plot_predictions, plot_weekly_predictions, plot_weekly_difference, plot_weekly_evaluation, plot_prediction_length_vs_metric, plot_responsiveness_vs_metric, plot_model_weights, plot_model_weights_all_weeks, plot_weights_by_shift_length_over_weeks
# from .Models import replace_negatives, stats_data, ARIMA_model, ml_model, gen_ml, arima_res_xgb
# from .Processor import read_data, get_hyperparameters, populate_tuned_model_dict, populate_tuned_model_dict_with_defaults, read_model_results, read_grid_search_results, create_MAPE_df, create_prediction_df, calculate_model_MAPE, extract_predictions_from_dict, extract_predictions_from_dict, extract_all_predictions_from_dict, split_data_history_now_casting
# from .GridSearch import get_wave_data_dictionary, stat_train, run_grid_search_for_each_key, run_grid_search, run_auto_arima_for_each_key
# from .Weighted import find_optimal_weights, find_diff, find_stan_optimal_weights, find_weighted_predictions

# Wave-related imports
from .Wave import Wave, generate_train_end_date, generate_test_start_date

# Processor utilities
from .Processor import (
    TimeSeriesSplit,
    extract_model_weights_from_dict,
    extract_predictions_from_dict,
    extract_all_predictions_from_dict,
    read_data,
    get_hyperparameters,
    populate_tuned_model_dict,
    populate_tuned_model_dict_with_defaults,
    read_model_results,
    read_grid_search_results,
    create_MAPE_df,
    create_prediction_df,
    calculate_model_MAPE,
    split_data_history_now_casting,
    split_data_into_waves,
    extract_wave_id,
    safe_to_datetime,
    extract_shift_from_key,
    format_stan_optimal_weights,
    extract_evaluation_from_dict
)

# Prediction functions
from .Predictions import (
    wave_prediction,
    wave_prediction_with_models,
    find_prediction_current_week,
    seperate_model_eval,
    model_eval_on_future,
    forecast_current_weeks
)

# Visualization tools
from .Visualization import (
    visualize_wave_shifts,
    visualize_weekly_case_count_all_model_each_wave,
    visualize_weekly_MAPE_all_model_each_wave,
    plot_predictions,
    plot_weekly_predictions,
    plot_weekly_difference,
    plot_weekly_evaluation,
    plot_prediction_length_vs_metric,
    plot_responsiveness_vs_metric,
    plot_model_weights,
    plot_model_weights_all_weeks,
    plot_weights_by_shift_length_over_weeks,
    describe_and_plot_waves,
    visualize_wave_train_test_with_shift_PL,
    plot_wave_train_test_shift_PL,
    plot_train_test_by_shifts_prediction_lengths_for_wave_horizontal,
    visualize_wave_shift_cross_validation,
    plot_time_series_cv_splits
)

# Models
from .Models import (
    replace_negatives,
    stats_data,
    ARIMA_model,
    ml_model,
    gen_ml,
    arima_res_xgb
)

# Grid Search functionality
from .GridSearch import (
    get_wave_data_dictionary,
    stat_train,
    run_grid_search,
    run_grid_search_for_each_key,
    run_auto_arima_for_each_key,
    tune_models_for_one_condition,
    tune_models_for_all_conditions,
    hyperparameter_tuning_forecast_current_weeks
)

# Weight optimization and MLAMA prediction
from .Weighted import (
    find_optimal_weights,
    find_diff,
    find_stan_optimal_weights,
    find_weighted_predictions
)